Bug 829116 - Review Request: ninja-build - A small build system with a focus on speed
Review Request: ninja-build - A small build system with a focus on speed
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Scherer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-05 23:29 EDT by Ben Boeckel
Modified: 2016-01-13 22:33 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-14 21:31:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
misc: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
"patch" to fix vim auto-syntax (86 bytes, text/plain)
2012-06-18 09:49 EDT, Matthew Woehlke
no flags Details

  None (edit)
Description Ben Boeckel 2012-06-05 23:29:46 EDT
Spec URL: http://benboeckel.net/packaging/ninja-build/ninja-build.spec
SRPM URL: http://benboeckel.net/packaging/ninja-build/ninja-build-0-0.2.20120605git54553d3.fc18.src.rpm
Description:
Ninja is a small build system with a focus on speed. It differs from other                                                                                                                                                                 
build systems in two major respects: it is designed to have its input files                                                                                                                                                                
generated by a higher-level build system, and it is designed to run builds as                                                                                                                                                              
fast as possible.

Fedora Account System Username: mathstuf

% lintmock fedora-rawhide-x86_64
ninja-build.src: W: strange-permission ninja-build.spec 0640L
ninja-build.src: W: strange-permission martine-ninja-54553d3.tar.gz 0640L
ninja-build.src: W: invalid-url Source0: martine-ninja-54553d3.tar.gz
ninja-build.x86_64: W: non-conffile-in-etc /etc/bash_completion.d/ninja-bash-completion
ninja-build.x86_64: W: no-manual-page-for-binary ninja
3 packages and 0 specfiles checked; 0 errors, 5 warnings.
Comment 1 Matthew Woehlke 2012-06-06 12:23:11 EDT
Missing "Group: Development/Tools"?

Is there a reason lintmock doesn't like your SRPM file permissions? (i.e. is there a reason they are like that?)

(xz takes ~18 KiB off the .tar.gz)
Comment 2 Ben Boeckel 2012-06-07 18:06:04 EDT
(In reply to comment #0)
Spec URL: http://benboeckel.net/packaging/ninja-build/ninja-build.spec
SRPM URL: http://benboeckel.net/packaging/ninja-build/ninja-build-0-0.3.20120605git54553d3.fc18.src.rpm

Add a Group tag.

The permissions are due to my umask of 027. They'll be fine when built on Koji.

The .gz file is direct from github, not homespun.
Comment 3 Matthew Woehlke 2012-06-07 20:05:34 EDT
(In reply to comment #2)
> Add a Group tag.

Thanks.

> The permissions are due to my umask of 027. They'll be fine when built on
> Koji.

If koji fixes them, that's okay then...

> The .gz file is direct from github, not homespun.

Ah. Though, in that case, can not the source URL be https://github.com/martine/ninja/tarball/%{githash}? :-)



I'll try to get to a full review over the weekend when I have free time.
Comment 4 Matthew Woehlke 2012-06-13 00:25:32 EDT
(MUST) rpmlint output is missing for latest packages. (In particular, the latest changelog entry is missing the git hash, which I assume is why rpmlint reports "incoherent-version-in-changelog 0-0.3.20120605git".)

(MUST) python is not listed as a BuildRequires? (I would be willing to believe python is an exception, though unless I am blind, I don't see it in http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2?)

(MUST) /usr/share/zsh/site-functions/ is not owned by the package or any required packages

(SHOULD) currently, no manpage is known to be available (upstream or otherwise)

MUST items verified:
- name is okay
- .spec name is okay
- package meets guidelines AFAICS (pity there is no bash-completion-filesystem)
- code license is okay (ASL 2.0; did spot check of sources to verify)
- .spec gives correct license
- COPYING present in rpm
- .spec is en_US and is legible
- builds successfully on x86_64
- no locale-dependent data
- no static or shared libraries (also covers -static, -devel)
- does not bundle system libs
- no files are listed more than once in %files
- permissions look okay
- macro use is consistent AFAICT
- package content is permissible
- doc is not large, and not required for execution
- no .la's
- not a GUI application
- all file names are ASCII

Was unable to verify source tarball checksum, probably due to how it was generated. Did clone upstream git repo and verified directory contents (diff -ru) are the same. (Curiously, the tarball I generated with 'git archive' is identical size, and 'tar tvf' listings are also identical. Also, consider giving either github URL or git archive command in .spec to make it easier for curious folk to regenerate the tarball.)

I don't have ready access to verify if it FTB on any architectures, but have no reason to believe it wouldn't build. Ergo, no ExcludeArch expected.

I am insufficiently familiar with relocatable packages; I don't believe it is or is intended to be?

Owns /etc/bash_completion.d (along with at least a half dozen other packages). One could read this as a violation of a MUST, but as I understand the directory ownership issue in this case, it is okay.

SHOULD items verified:
- license comes from upstream
- program appears to run correctly
- bash completion works
Comment 5 Matthew Woehlke 2012-06-13 11:45:34 EDT
vim syntax doesn't seem to work OOTB? (should it? or is this expected?)
Comment 6 Matthew Woehlke 2012-06-18 09:49:14 EDT
Created attachment 592653 [details]
"patch" to fix vim auto-syntax

So, it's not too hard to fix the previous point; necessary vim commands attached. I put this in vimfiles/ftdetect, but not sure if that's the appropriate place (maybe it should be part of syntax/ninja.vim?).
Comment 7 Ben Boeckel 2012-06-19 23:10:35 EDT
Spec URL: http://benboeckel.net/packaging/ninja-build/ninja-build.spec
SRPM URL: http://benboeckel.net/packaging/ninja-build/ninja-build-0-0.4.20120605git54553d3.fc18.src.rpm

Fixed vim/ftdetect, zsh-stuff ownership, and githash missing from some changelogs.
Comment 8 Matthew Woehlke 2012-06-20 14:27:35 EDT
Confirmed items from comment #4 are fixed (also that vim auto-syntax now works, as advertised). The only outstanding issue I see is the missing manpage, which IMO should not be a blocker.

Now... just need someone that's already a packager to verify :-).
Comment 9 Michael Scherer 2012-07-08 09:02:14 EDT
Hi, guideline ask that you give the list of command to generate the tarball, or the url :
https://fedoraproject.org/wiki/Packaging:SourceURL
Comment 10 Michael Scherer 2012-07-08 09:57:34 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Package is not relocatable.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "*No copyright* UNKNOWN", "Apache (v2.0) GENERATED FILE"
     For detailed output of licensecheck see file:
     /home/misc/checkout/git/FedoraReview/829116-ninja-build/licensecheck.txt
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[!]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[!]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Rpmlint
-------
Checking: ninja-build-debuginfo-0-0.4.20120605git54553d3.fc17.x86_64.rpm
          ninja-build-0-0.4.20120605git54553d3.fc17.src.rpm
          ninja-build-0-0.4.20120605git54553d3.fc17.x86_64.rpm
ninja-build.src: W: strange-permission ninja-build.spec 0640L
ninja-build.src: W: strange-permission martine-ninja-54553d3.tar.gz 0640L
ninja-build.src: W: strange-permission ninja.vim 0640L
ninja-build.src: W: invalid-url Source0: martine-ninja-54553d3.tar.gz
ninja-build.x86_64: W: non-conffile-in-etc /etc/bash_completion.d/ninja-bash-completion
ninja-build.x86_64: W: no-manual-page-for-binary ninja
3 packages and 0 specfiles checked; 0 errors, 6 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint ninja-build-debuginfo ninja-build
ninja-build-debuginfo.x86_64: I: enchant-dictionary-not-found en_US
ninja-build.x86_64: W: non-conffile-in-etc /etc/bash_completion.d/ninja-bash-completion
ninja-build.x86_64: W: no-manual-page-for-binary ninja
2 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'

Requires
--------
ninja-build-debuginfo-0-0.4.20120605git54553d3.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    

ninja-build-0-0.4.20120605git54553d3.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    emacs-filesystem  
    libc.so.6()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libm.so.6()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    rtld(GNU_HASH)  
    vim-filesystem  

Provides
--------
ninja-build-debuginfo-0-0.4.20120605git54553d3.fc17.x86_64.rpm:
    
    ninja-build-debuginfo = 0-0.4.20120605git54553d3.fc17
    ninja-build-debuginfo(x86-64) = 0-0.4.20120605git54553d3.fc17

ninja-build-0-0.4.20120605git54553d3.fc17.x86_64.rpm:
    
    ninja-build = 0-0.4.20120605git54553d3.fc17
    ninja-build(x86-64) = 0-0.4.20120605git54553d3.fc17

MD5-sum check
-------------


Generated by fedora-review 0.2.0git
External plugins:


So there is 2 issues, the command for the tarball, and 

[!]: SHOULD Packages should try to preserve timestamps of original installed
     files.
Comment 11 Ben Boeckel 2012-07-09 23:19:25 EDT
Spec URL: http://benboeckel.net/packaging/ninja-build/ninja-build.spec
SRPM URL: http://benboeckel.net/packaging/ninja-build/ninja-build-0-0.4.20120605git54553d3.fc18.src.rpm

Switched to passing -p to install. Installed as /usr/bin/ninja-build (to avoid conflicts with the ninja package). URL for the tarball given.
Comment 12 Michael Scherer 2012-07-12 13:56:23 EDT
Ok, the issue were corrected, so let's say "good to go" :)
Comment 13 Ben Boeckel 2012-07-12 14:11:36 EDT
Thanks!

New Package SCM Request
=======================
Package Name: ninja-build
Short Description: A small build system with a focus on speed
Owners: mathstuf
Branches: f16 f17
InitialCC:
Comment 14 Gwyn Ciesla 2012-07-14 22:36:13 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2012-11-04 22:05:36 EST
ninja-build-1.0.0-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/ninja-build-1.0.0-1.fc17
Comment 16 Fedora Update System 2012-11-04 22:05:51 EST
ninja-build-1.0.0-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ninja-build-1.0.0-1.fc18
Comment 17 Fedora Update System 2012-11-04 22:06:02 EST
ninja-build-1.0.0-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/ninja-build-1.0.0-1.fc16
Comment 18 Fedora Update System 2012-11-05 17:43:11 EST
ninja-build-1.0.0-1.fc18 has been pushed to the Fedora 18 testing repository.
Comment 19 Fedora Update System 2012-11-14 21:31:03 EST
ninja-build-1.0.0-1.fc16 has been pushed to the Fedora 16 stable repository.
Comment 20 Fedora Update System 2012-11-14 21:38:22 EST
ninja-build-1.0.0-1.fc17 has been pushed to the Fedora 17 stable repository.
Comment 21 Jens Petersen 2016-01-13 22:33:47 EST
(It is kind of a shame that the package could not just be called ninja and provide /usr/bin/ninja due to the existing ninja irc client package...)

Note You need to log in before you can comment on or make changes to this bug.